local L = LibStub("AceLocale-3.0"):GetLocale("NeedjaTrackerPlus", true)

NTP = LibStub("AceAddon-3.0"):NewAddon("NeedjaTrackerPlus", "AceConsole-3.0", "AceEvent-3.0")

local S2K = LibStub("S2Kmisc-1.0")

function NTP:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("NeedjaTrackerPlusDB", self:Defaults(), true)

    self.db.RegisterCallback(self, "OnProfileReset", "UpdateConfig")
    self.db.RegisterCallback(self, "OnProfileChanged", "UpdateConfig")
    self.db.RegisterCallback(self, "OnProfileCopied", "UpdateConfig")

    LibStub("AceConfig-3.0"):RegisterOptionsTable("NeedjaTrackerPlus", self:Options())

    local dlg = LibStub("AceConfigDialog-3.0")

    dlg:AddToBlizOptions("NeedjaTrackerPlus", L.title, nil, "general")
    dlg:AddToBlizOptions("NeedjaTrackerPlus", L.cfg_profiles, L.title, "profiles")

    ChatFrame_AddMessageEventFilter("CHAT_MSG_LOOT", function(this, ...) return self:FilterChatMessage(...) end)

    self:UpdateConfig()
end

function NTP:OnEnable()
    self:RegisterEvent("CHAT_MSG_LOOT", "ProcessChatMessage")
end

function NTP:OnDisable()
end

function NTP:FilterChatMessage(event, msg)
    return self:GetProfileValue("enable") and S2K:ParseMsgMatchTable(S2K.LOOT_ROLL_MSG_MATCH_TABLE, msg)
end

function NTP:ProcessChatMessage(event, msg)
    local handler, args = S2K:ParseMsgMatchTable(S2K.LOOT_ROLL_MSG_MATCH_TABLE, msg)

    if handler == "LOOT_ROLL_ALL_PASSED" then
        print(handler, args.item)

    elseif handler == "LOOT_ROLL_CHOSE" then
        print(handler, args.player, args.item, args.choice)

    elseif handler == "LOOT_ROLL_ROLLED" then
        print(handler, args.player, args.item, args.choice, args.roll)

    elseif handler == "LOOT_ROLL_WON" then
        print(handler, args.player, args.item)

    elseif handler == "LOOT_ROLL_WON_NO_SPAM" then
        print(handler, args.player, args.item, args.choice, args.roll)
    end
end

function NTP:UpdateConfig()
    if self:GetProfileValue("enable") then
        self:Enable()
    else
        self:Disable()
    end
end

function NTP:GetProfileValue(key)
    return self.db.profile[key]
end

function NTP:SetProfileValue(key, value)
    self.db.profile[key] = value
end

function NTP:GetCharValue(key)
    return self.db.char[key]
end

function NTP:SetCharValue(key, value)
    self.db.char[key] = value
end
